<?php
/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 08/04/14
 * Time: 14:08
 */

namespace Geral\Logic\Cadastros;

class ParceiroDeNegocio {

    const FORMA_COMUNICACAO_TELEFONE = '01';
    const TIPO_ENDERECO = 'PRINCIPAL';

    public static function novo($nrorg, $nmprincipalparc, $nmsecundariparc, $cdcomunicaparc, $cdpais, $sgestado,
                                $cdmunicipio)
    {
        $parceiro = self::novoParceiro($nrorg, $nmprincipalparc, $nmsecundariparc);
        $parceiro->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

        $endereco = \Geral\Logic\Cadastros\ParceiroDeNegocio\Endereco::novo(
            $nrorg, $parceiro->getNrparcnegocio(), self::TIPO_ENDERECO, $cdpais, $sgestado, $cdmunicipio
        );
        $endereco->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

        $comunicacao = \Geral\Logic\Cadastros\ParceiroDeNegocio\Comunicacao::novo(
            $nrorg, $parceiro->getNrparcnegocio(), self::FORMA_COMUNICACAO_TELEFONE, $cdcomunicaparc
        );
        $comunicacao->persist();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

        return $parceiro;
    }

    /**
     * @param $nrorg
     * @param $nmprincipalparc
     * @param $nmsecundariparc
     * @param $nrinscricaoparc
     * @return \Geral\Entities\Parcnegocio
     */
    private static function novoParceiro($nrorg, $nmprincipalparc, $nmsecundariparc)
    {
        $parceiro = new \Geral\Entities\Parcnegocio();
        $parceiro->setNrorg($nrorg);
        $parceiro->setNmprincipalparc($nmprincipalparc);
        $parceiro->setNmsecundariparc($nmsecundariparc);
        $parceiro->setNrparcnegocio($parceiro->getRepository()->maxNrparcnegocio());
        $parceiro->setNrinscricaoparc(\Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorgTrabalho(),'PARCNEGOCIO',1,4,true));
        $parceiro->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
        $parceiro->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $parceiro->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());
        $parceiro->setIdparcfundido('N');
        return $parceiro;
    }

} 