const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const tipoDeGestaoFiscalPage = require('../../../page-objects/parametrizacao/documentos fiscais/tipoDeGestaoFiscal.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela Tipo de Gestão Fiscal', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        tipoDeGestaoFiscalPage.abrir();
        z.component.footer.clickRightActionByLabel('Filtrar', true);
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Acessar a tela Tipo de Gestão Fiscal', () => {
        expect(z.component.header.getTitle()).toBe('Tipo de Gestão Fiscal');
    });

    it('Adicionar Registro', () => {
        tipoDeGestaoFiscalPage.adicionartipoDeGestaoFiscal(j.getValor('cdtpfaturfis1'), j.getValor('nmtpfaturfis1'));
        geralPage.filterIt(j.getValor('nmtpfaturfis1'));
        expect(geralPage.gridHasText('189541530512463473573301', j.getValor('nmtpfaturfis1'), 1)).toBe(j.getValor('nmtpfaturfis1'));
    });

    it('Adicionar Unidade Por Gestão Fiscal', () => {
        geralPage.filterIt(j.getValor('nmtpfaturfis1'));
        geralPage.clickGrid('NMTPFATURFIS', j.getValor('nmtpfaturfis1'), '189541530512463473573301', false);
        geralPage.trocarAba('Unidade/Tipo de Gestão Fiscal');
        tipoDeGestaoFiscalPage.adicionarUnidadePorGestaoFiscal(j.getValor('unidade'));
        geralPage.clickSalvar();
        expect(geralPage.gridHasText('189541530539926837503302', j.getValor('unidade'), 1)).toBe(j.getValor('unidade'));
    });

    it('Editar Registro', () => {
        geralPage.filterIt(j.getValor('nmtpfaturfis1'));
        geralPage.clickGrid('NMTPFATURFIS', j.getValor('nmtpfaturfis1'), '189541530512463473573301', false);
        geralPage.clickEditar();
        tipoDeGestaoFiscalPage.editartipoDeGestaoFiscal(j.getValor('nmtpfaturfis2'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('NMTPFATURFIS')).toBe(j.getValor('nmtpfaturfis2'));
    });

    it('Excluir Registro', () => {
        geralPage.filterIt(j.getValor('nmtpfaturfis2'));
        geralPage.clickGrid(('NMTPFATURFIS'), j.getValor('nmtpfaturfis2'), '189541530512463473573301');
        tipoDeGestaoFiscalPage.excluirtipoDeGestaoFiscal();
        expect(geralPage.gridHasText('189541530512463473573301', j.getValor('nmtpfaturfis2'), 1, false)).toBeUndefined();
    });
});
